"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TerminationBase = void 0;
class TerminationBase {
    constructor() {
        this._hasReached = false;
        // eslint-disable-next-line no-magic-numbers
        this._progress = 0;
    }
    get progress() {
        return this._progress;
    }
    init() {
        this._hasReached = false;
        this._progress = 0;
        this.performInit();
    }
    performInit() {
        // override if required
    }
    hasReached(algorithm) {
        if (!this._hasReached) {
            this._hasReached = this.performHasReached(algorithm);
            if (this._hasReached) {
                this._progress = 1;
            }
            else {
                this._progress = this.performGetProgress(algorithm);
            }
        }
        return this._hasReached;
    }
}
exports.TerminationBase = TerminationBase;
//# sourceMappingURL=TerminationBase.js.map